﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace InnderWord
{
    public partial class OfficeEmbed : UserControl
    {
        public OfficeEmbed()
        {
            InitializeComponent();
            //Word();
        }

        OfficeBase we = null;
        /// <summary>
        /// 
        /// </summary>
        /// <param name="fileName"></param>
        public void LoadFile(string fileName)
        {
            Close();
            System.IO.FileInfo file = new System.IO.FileInfo(fileName);
            string extension = file.Extension;
            this.Controls.Clear();

            switch (extension)
            {
                case ".doc":
                case ".docx":
                case ".dot":
                    we = new WordEmbed();
                    break;
                case ".xls":
                case ".xlsx":
                     we = new ExcelEmbed();
                    break;
                case ".ppt":
                     we = new PPTEmbed();
                    break;
                default:
                    break;
            }

            we.LoadFile(fileName, this.Handle.ToInt32());
            this.SizeChanged += delegate
            {
                we.OnResize(this.Handle.ToInt32());
            };     
            
            
        }
        /// <summary>
        /// 保存文档
        /// </summary>
        public void Save()
        {
            we.Save();           
        }
        /// <summary>
        /// 关闭文档
        /// </summary>
        public void Close()
        {
            if (we != null)
            {
                we.Close();
            }
        }
     
    }
}
