﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Office.Interop.PowerPoint;
using System.Windows.Forms;
namespace InnderWord
{
    public class PPTEmbed : OfficeBase
    {
        public PPTEmbed()
        {
            
        }
        private ApplicationClass pptClass;
        private Presentation preSentation;
        private int HandleId = 0;
        private IntPtr pptWnd =IntPtr.Zero;
        private object Nothing = System.Reflection.Missing.Value;        
        private string FileName;

        private void pptClass_PresentationClose(Presentation pre)
        {
           // Save();
            pre.Save();
        }
        /// <summary>
        /// 加载word文件
        /// </summary>
        /// <param name="fileName">文件路径</param>
        /// /// <param name="handleId">父窗口句柄ID</param>
        public void LoadFile(string fileName, int handleId)
        {
            try
            {
                if (pptClass == null)
                {
                    pptClass = new ApplicationClass();
                }
                FileName = fileName;
                HandleId = handleId;
                pptClass.CommandBars.AdaptiveMenus = false;
                //pptClass.Assistant.On = false;
                pptClass.PresentationClose+=new EApplication_PresentationCloseEventHandler(pptClass_PresentationClose);
                //pptClass.docum
                if (preSentation != null)
                {
                    //pptClass.P();
                }
                ///加载文档
                if (pptWnd == IntPtr.Zero)
                {
                    //pptWnd = WinAPI.FindWindow("PP11FrameClass", null);
                    pptWnd = WinAPI.FindWindow("PPTFrameClass", null);//office2010
                    WinAPI.SetParent(pptWnd.ToInt32(), handleId);                   

                    object filename = fileName;
                    object newTemplate = false;
                    object docType = 0;
                    object readOnly = true;
                    object isVisible = true;
                    if (pptClass != null && pptClass.Presentations != null)
                    {
                        //pptClass.Presentations.Add(Microsoft.Office.Core.MsoTriState.msoTrue);
                        //pptClass.Presentations.Open(fileName,Microsoft.Office.Core.MsoTriState.msoFalse,Microsoft.Office.Core.MsoTriState.msoCTrue,Microsoft.Office.Core.MsoTriState.msoCTrue)
                        preSentation = pptClass.Presentations.Open(FileName,
                            Microsoft.Office.Core.MsoTriState.msoFalse,
                            Microsoft.Office.Core.MsoTriState.msoFalse,
                            Microsoft.Office.Core.MsoTriState.msoFalse);
                        pptClass.Visible = Microsoft.Office.Core.MsoTriState.msoTrue;
                        preSentation.NewWindow();//此处显示打开的文档                        
                    }
                    if (preSentation == null)
                    {
                        //throw new Exception("PPT文档加载失败！");
                    }
                }
                SetExcelStyle(handleId);
                //SetCommandBars();
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        /// <summary>
        /// 设置打开word文档的样式 
        /// </summary>
        /// <param name="pptClass"></param>
        private void SetExcelStyle(int handleId)
        {
            if (pptClass != null)
            {
                //pptClass.Activate();
                //pptClass.Activate();
                //pptClass.ActiveWindow.ViewType = PpViewType.ppViewNormal;      
                //pptClass.Presentations.Add(Microsoft.Office.Core.MsoTriState.
                //pptClass.ActiveWindow.WindowState = PpWindowState.ppWindowMaximized;     
                WinAPI.SetWindowPos(pptWnd, handleId, 0, 0,
                    Form.FromHandle((IntPtr)handleId).Bounds.Width,
                    Form.FromHandle((IntPtr)handleId).Bounds.Height,
                    SetWindowPosFlags.SWP_NOZORDER |
                    SetWindowPosFlags.SWP_NOMOVE |
                    SetWindowPosFlags.SWP_DRAWFRAME |
                    SetWindowPosFlags.SWP_NOSIZE);
                pptClass.Activate();
                //pptClass.ActiveWindow.ViewType = PpViewType.ppViewNormal;
                OnResize(handleId);
            }
        }
        /// <summary>
        /// 设置word上面工具栏
        /// </summary>
        private void SetCommandBars()
        {
            if (pptClass != null)
            {
                int count = pptClass.CommandBars.Count;
                for (int j = 1; j <= count; j++)
                {
                    string menuName = pptClass.CommandBars[j].Name;
                    if (menuName == "Standard")
                    {
                        int count_control = pptClass.ActiveWindow.Application.CommandBars[j].Controls.Count;
                        for (int k = 1; k <= 2; k++)
                        {
                            pptClass.ActiveWindow.Application.CommandBars[j].Controls[k].Enabled = false;
                        }
                    }
                    if (menuName == "Menu Bar")
                    {
                        pptClass.ActiveWindow.Application.CommandBars[j].Enabled = false;
                    }
                    menuName = "";
                }
                ///移除按钮
                int hMenu = WinAPI.GetSystemMenu(pptWnd, false);
                if (hMenu > 0)
                {
                    int menuItemCount = WinAPI.GetMenuItemCount(hMenu);
                    for (int m = 1; m <= 8; m++)
                    {
                        WinAPI.RemoveMenu(hMenu, menuItemCount - m, WinAPI.MF_REMOVE | WinAPI.MF_BYPOSITION);
                    }
                    WinAPI.DrawMenuBar(pptWnd);
                }
            }

        }
        /// <summary>
        /// 保存打开的文件
        /// </summary>
        public void Save()
        {
            if (preSentation != null)
            {
                preSentation.SaveAs(FileName, PpSaveAsFileType.ppSaveAsDefault, Microsoft.Office.Core.MsoTriState.msoFalse);
            }
        }
        /// <summary>
        /// 关闭打开的文件
        /// </summary>
        public void Close()
        {
            Save();
            if (preSentation != null)
            {
                preSentation.Close();               
                System.Runtime.InteropServices.Marshal.ReleaseComObject(preSentation);
                preSentation = null;
            }
            if (pptClass != null)
            {
                pptClass.Quit();
                //WinAPI.SendMessage(pptWnd, 0x10, 0, 0);
                System.Runtime.InteropServices.Marshal.ReleaseComObject(pptClass);
                pptClass = null;
                KillPptProcess();
            }
            GC.Collect();
        }
        /// <summary>
        /// 当大小发生改变时
        /// </summary>
        public void OnResize(int handleId)
        {
            int borderWidth = SystemInformation.Border3DSize.Width;
            int borderHeight = SystemInformation.Border3DSize.Height;
            int captionHeight = SystemInformation.CaptionHeight;
            int statusHeight = SystemInformation.ToolWindowCaptionHeight;
            WinAPI.MoveWindow(
                pptWnd,
                -2 * borderWidth,
                -2 * borderHeight - captionHeight,
                Form.FromHandle((IntPtr)handleId).Bounds.Width + 4 * borderWidth,
                Form.FromHandle((IntPtr)handleId).Bounds.Height + captionHeight + 4 * borderHeight + statusHeight,
                true);
        }
        /// <summary>
        ///文档关闭前
        /// </summary>
        /// <param name="doc"></param>
        /// <param name="bCancel"></param>
        private void pptClass_preSentationBeforeClose(Presentation doc, ref bool bCancel)
        {
            //Save();//确保文档关闭前能保存
            bCancel = true;
        }
        /// <summary>
        /// 杀PPT进程
        /// </summary>
        void KillPptProcess()
        {
            System.Diagnostics.Process[] processArr = System.Diagnostics.Process.GetProcesses();
            foreach (System.Diagnostics.Process p in processArr)
            {
                if (p.ProcessName.ToUpper() == "POWERPNT")
                {
                    p.Kill();
                    break; 
                }
            }
        }
    }
}
