﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Office.Interop.Word;
using System.Windows.Forms;

namespace InnderWord
{
    public class WordEmbed:OfficeBase
    {
        public WordEmbed()
        {
        }
        private Document document = null;       
        private ApplicationClass wdClass = null;
        private IntPtr wordWnd =IntPtr.Zero;
        private object Nothing = System.Reflection.Missing.Value;
       
        /// <summary>
        /// 加载word文件
        /// </summary>
        /// <param name="fileName">文件路径</param>
        /// /// <param name="handleId">父窗口句柄ID</param>
        public void LoadFile(string fileName,int handleId)
        {
            try
            {
                if (wdClass == null)
                {
                    wdClass = new ApplicationClass();
                }

                wdClass.CommandBars.AdaptiveMenus = false;
                wdClass.DocumentBeforeClose += new ApplicationEvents4_DocumentBeforeCloseEventHandler(wdClass_DocumentBeforeClose);
                //wdClass.docum
                if (document != null)
                {
                    wdClass.Documents.Close(ref Nothing, ref Nothing, ref Nothing);
                }
                ///加载文档
                if (wordWnd == IntPtr.Zero)
                {
                    wordWnd = WinAPI.FindWindow("Opusapp", null);
                    WinAPI.SetParent(wordWnd.ToInt32(), handleId);

                    object filename = fileName;
                    object newTemplate = false;
                    object docType = 0;
                    object readOnly = false;
                    object isVisible = true;
                    if (wdClass != null && wdClass.Documents != null)
                    {
                        document = wdClass.Documents.Open(ref filename, ref Nothing,
                            ref readOnly, ref Nothing, ref Nothing,
                            ref Nothing, ref Nothing, ref Nothing,
                            ref Nothing, ref Nothing, ref Nothing,
                            ref isVisible, ref Nothing, ref Nothing,
                            ref Nothing, ref Nothing);
                    }
                    if (document == null)
                    {
                        //throw new Exception("Word文档加载失败！");
                    }
                }
                SetWordStyle(handleId);
                //SetCommandBars();//工具栏就不隐藏了
            }
            catch (Exception ex)
            {
                //throw ex;
            }
        }
        /// <summary>
        /// 设置打开word文档的样式 
        /// </summary>
        /// <param name="wdClass"></param>
        private void SetWordStyle(int handleId)
        {
            if (wdClass != null)
            {
                //wdClass.ActiveWindow.DisplayHorizontalScrollBar = false;
                //wdClass.ActiveWindow.DisplayLeftScrollBar = false;
                //wdClass.ActiveWindow.DisplayRightRuler = false;
                //wdClass.ActiveWindow.DisplayRulers = false;
                //wdClass.ActiveWindow.DisplayScreenTips = false;
                //wdClass.ActiveWindow.DisplayVerticalRuler = false;
                //wdClass.ActiveWindow.DisplayVerticalScrollBar = false;
                //wdClass.ActiveWindow.ActivePane.DisplayRulers = false;
                //wdClass.ActiveWindow.ActivePane.DisplayVerticalRuler = false;
                wdClass.ActiveWindow.ActivePane.View.Type = WdViewType.wdWebView;
                document.Activate();
                wdClass.Visible = true;              
                WinAPI.SetWindowPos(wordWnd, handleId, 0, 0,
                    Form.FromHandle((IntPtr)handleId).Bounds.Width,
                    Form.FromHandle((IntPtr)handleId).Bounds.Height,
                    SetWindowPosFlags.SWP_NOZORDER |
                    SetWindowPosFlags.SWP_NOMOVE |
                    SetWindowPosFlags.SWP_DRAWFRAME |
                    SetWindowPosFlags.SWP_NOSIZE);

                OnResize(handleId);
            }         
        }
        /// <summary>
        /// 设置word上面工具栏
        /// </summary>
        private void SetCommandBars()
        {
            if (wdClass != null)
            {
                int count = wdClass.CommandBars.Count;
                for (int j = 1; j <= count; j++)
                {
                    string menuName = wdClass.CommandBars[j].Name;
                    if (menuName == "Standard")
                    {
                        int count_control = wdClass.ActiveWindow.Application.CommandBars[j].Controls.Count;
                        for (int k = 1; k <= 2; k++)
                        {                            
                            wdClass.ActiveWindow.Application.CommandBars[j].Controls[k].Enabled = false;
                        }
                    }
                    if (menuName == "Menu Bar")
                    {
                        wdClass.ActiveWindow.Application.CommandBars[j].Enabled = false;
                    }
                    menuName = "";
                }
                ///移除按钮
                int hMenu = WinAPI.GetSystemMenu(wordWnd, false);
                if (hMenu > 0)
                {
                    int menuItemCount = WinAPI.GetMenuItemCount(hMenu);
                    for (int m = 1; m <= 8; m++)
                    {
                        WinAPI.RemoveMenu(hMenu, menuItemCount -m, WinAPI.MF_REMOVE | WinAPI.MF_BYPOSITION);
                    }                    
                    WinAPI.DrawMenuBar(wordWnd);
                }
            }

        }
        /// <summary>
        /// 保存打开的文件
        /// </summary>
        public void Save()
        {
            if (document != null)
            {
                document.Save();
            }
        }
        /// <summary>
        /// 关闭打开的文件
        /// </summary>
        public void Close()
        {
            Save();
            object saveChanges=false;
            Object MissingValue=System.Reflection.Missing.Value;
            //document.Close(ref MissingValue, ref MissingValue, ref MissingValue);//此处出错（不知为何）
           wdClass.Quit(ref Nothing, ref Nothing, ref Nothing);
           System.Runtime.InteropServices.Marshal.ReleaseComObject(wdClass);
           wdClass = null;
        }
        /// <summary>
        /// 当大小发生改变时
        /// </summary>
        public void OnResize(int handleId)
        {
            int borderWidth = SystemInformation.Border3DSize.Width;
            int borderHeight = SystemInformation.Border3DSize.Height;
            int captionHeight = SystemInformation.CaptionHeight;
            int statusHeight = SystemInformation.ToolWindowCaptionHeight;
            WinAPI.MoveWindow(
                wordWnd,
                -2 * borderWidth,
                -2 * borderHeight - captionHeight,
                Form.FromHandle((IntPtr)handleId).Bounds.Width + 4 * borderWidth,
                Form.FromHandle((IntPtr)handleId).Bounds.Height + captionHeight + 4 * borderHeight + statusHeight,
                true);
        }
        /// <summary>
        ///文档关闭前
        /// </summary>
        /// <param name="doc"></param>
        /// <param name="bCancel"></param>
        private void wdClass_DocumentBeforeClose(Document doc, ref bool bCancel)
        {
            Save();//确保文档关闭前能保存
            bCancel = true;
        }
    }
}
